% Zeigen Sie, dass die Funktion swap: (I*)2 -> (I*)2 mit swap(x,y) = swap(y,x)
% turing-berechenbar ist, indem sie dazu eine Turing-Maschine angeben.
% Prüfen Sie Ihr Ergebnis mit den von der Veranstaltungsseite erhältlichen Tests,
% Ihre Turing-Masche soll dazu in einer Datei TMswap.tm direkt im Projektverzeichnis
% stehen.
% Hinweis: Obwohl "nur" ein #-Zeichen zu verschieben ist, ist die Lösung relativ komplex.
% Entwickeln mit Hilfe des Projektes inkrementell und prüfen Sie immer für neue Zustände
% ob das Ergebnis Ihren Erwartungen entspricht.

% Zustaende
Z: Start sucheStrich suchePartner streichePartner ersterStrich naechsterStrich 
Z: linksAbholen rechtsAbholen linksMarkieren linksKopieren blankSetzen 
Z: umwandeln umwandeln2 umwandelnRechts blankVerschieben blankUeberlaufen 
Z: rechtsUmwandeln zumTrennzeichen blankNachRechts letztenStrichSetzen 
Z: strichLinks S
% Alphabet  Leerzeichen # automatisch dabei
A: I . %
% Start
S: Start
% Ueberfuehrungsfunktion
Start               # sucheStrich         # L 
sucheStrich         # linksAbholen        # L //rechte Seite kleiner und zu Ende
sucheStrich         I suchePartner        . L 
suchePartner        I suchePartner        I L
suchePartner        . streichePartner     . R
streichePartner     I streichePartner     I L
streichePartner     . ersterStrich        . R
streichePartner     # ersterStrich        # R
ersterStrich        I naechsterStrich     . R
ersterStrich        # rechtsUmwandeln     # L //linke Seite kleiner und zu Ende, 
% erst linke Seite umwandeln, damit Cursor am Ende an richtiger Position
% merken, dass rechts noch ein Strich fehlt
suchePartner        # streichePartner     # L
naechsterStrich     I naechsterStrich     I R
naechsterStrich     # naechsterStrich     # R
naechsterStrich     . sucheStrich         . L
linksAbholen        I blankVerschieben    # R // diese sind zu verschieben
blankVerschieben    # blankUeberlaufen    I L // das Blank muss dasein
blankUeberlaufen    # linksAbholen        # L 
linksAbholen        . umwandeln           I L
linksAbholen        # umwandeln2          # R // waren keine I links
linksMarkieren      I linksKopieren       . R
linksKopieren       I linksKopieren       I R
linksKopieren       # blankSetzen         I L
blankSetzen         I linksAbholen        # L
blankSetzen         . umwandeln           I L
blankSetzen         # S                   # S
umwandeln           . umwandeln           I L
umwandeln           # umwandeln2          # R // linker Rand erreicht, wieder zurueck nach rechts
umwandeln2          I umwandeln2          I R
umwandeln2          # umwandelnRechts     # R // Trennsymbol gefunden
umwandelnRechts     . umwandelnRechts     I R
umwandelnRechts     I umwandelnRechts     I R
umwandelnRechts     # S                   # S
rechtsUmwandeln     . rechtsUmwandeln     I L
rechtsUmwandeln     # zumTrennzeichen     # R
zumTrennzeichen     I zumTrennzeichen     I R
zumTrennzeichen     # blankNachRechts     I R
blankNachRechts     I rechtsAbholen       # R
blankNachRechts     . umwandelnRechts     # R
rechtsAbholen       . letztenStrichSetzen # L
letztenStrichSetzen # umwandeln2          I R
rechtsAbholen       I strichLinks         # L
strichLinks         # blankNachRechts     I R
