package test.endlicherAutomat;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import alphabet.Wort;
import endlicherAutomat.EndlicherAutomat;
import regulaererAusdruck.RegulaererAusdruck;

public class AusdruckAusAutomatTest {
  @Test
  public void testAusdruckausAutomat() {
    
    /**** Regulaeren Ausdruck hier eintragen ****/
    
    String ausdruck = "((a+b))*";  // zu ersetzen, nur Beispiel
        
    System.out.println(ausdruck);
    EndlicherAutomat ea = new EndlicherAutomat();
    ea.stringAlsAutomat("""
        % Automat_det
        Z: z0 z1 z2
        E: z2 z1
        S: z0
        A: a b
        z0 a z1
        z0 a z2
        z2 b z0
        z2 b z1
        """);
    ea.deterministisch().minimieren();
    EndlicherAutomat ea2 = RegulaererAusdruck.alsAusdruck(ausdruck).alsAutomat().deterministisch().minimieren();
    
    ea2.zustandsnamenKuerzen();
    System.out.println(ea2);
    boolean erg = ea.istMinimalIsomorph(ea2);
    Wort w = null;
    String text = "";
    if(!erg) {
      w = ea.nichtGemeinsamesWort(ea2);
      System.out.println(ea);
      text = w + " nicht korrekt bearbeitet,"
        +" Ihr Automat:" + ea2.akzeptieren(w) + " korrekt:" 
        + ea.akzeptieren(w);
    }
    Assertions.assertTrue(erg, text);
  }
}
