package test.kontextfreieGrammatik;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import grammatik.KontextfreieGrammatik;
import zustand.Zustand;

public class KFGa_2nb_3nTest {
  private KontextfreieGrammatik sut;

  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new KontextfreieGrammatik();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "kontextfreiegrammatiken" + util.Util.FS + "KFGa_2nb_3n.kfg");
  }

  @ParameterizedTest
  @ValueSource(strings = {"aabbb", "aaaabbbbbb", "aaaaaaaaaabbbbbbbbbbbbbbb"})
  void testOK(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertTrue(erg, "\"" + wort + "\"" 
        + " sollte ableitbar sein in\n");
  }

  @ParameterizedTest
  @ValueSource(strings = {"", "a", "ab", "aabb", "aabbbb", "aaabbbbbb", "abb"})
  void testNicht(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertFalse(erg, "\"" + wort + "\"" 
        + " sollte nicht ableitbar sein in\n");
  }
}
