package test.kontextfreieGrammatik;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import grammatik.KontextfreieGrammatik;
import zustand.Zustand;

public class KFGendlichTest {
  private KontextfreieGrammatik sut;

  @BeforeEach
  public void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new KontextfreieGrammatik();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "kontextfreiegrammatiken" + util.Util.FS + "KFGendlich.kfg");
  }

  @ParameterizedTest
  @ValueSource(strings = {"", "aa", "bbb"})
  public void testOK(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertTrue(erg, "\"" + wort + "\"" 
        + " sollte ableitbar sein in\n");
  }

  @ParameterizedTest
  @ValueSource(strings = {"a", "b", "ab", "bb", "aaa", "bbbb", "aba"})
  public void testNicht(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertFalse(erg, "\"" + wort + "\"" 
        + " sollte nicht ableitbar sein in\n");
  }
}
