package test.kontextfreieGrammatik;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import grammatik.KontextfreieGrammatik;
import zustand.Zustand;

public class KFGleerTest {
  private KontextfreieGrammatik sut;

  @BeforeEach
  public void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new KontextfreieGrammatik();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "kontextfreiegrammatiken" + util.Util.FS + "KFGleer.kfg");
  }

  @ParameterizedTest
  @ValueSource(strings = {"", "a", "b", "ab", "aabb", "ba", "bb", "aba"})
  public void testNicht(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertFalse(erg, "\"" + wort + "\"" 
        + " sollte nicht ableitbar sein in\n");
  }
}
