package test.turingMaschine;

import org.junit.jupiter.api.Assertions;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Wort;
import alphabet.Zeichen;
import turingMaschine.TuringMaschine;
import zustand.Zustand;

public class TMABgeordnetTest {

  private TuringMaschine sut;
  
  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new TuringMaschine();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "turingmaschinen" + util.Util.FS + "TMABgeordnet.tm");
  }

  @Test
  void test1() {
    Wort erg = this.sut.berechnen("");
    Assertions.assertEquals("", erg.toString());
  }
  
  @Test
  void test2() {
    Wort erg = this.sut.berechnen("a");
    Assertions.assertEquals("a", erg.toString());
  }
  
  @Test
  void test3() {
    Wort erg = this.sut.berechnen("b");
    Assertions.assertEquals("b", erg.toString());
  }
  
  @Test
  void test4() {
    Wort erg = this.sut.berechnen("aaa");
    Assertions.assertEquals("aaa", erg.toString());
  }
  
  @Test
  void test5() {
    Wort erg = this.sut.berechnen("bbb");
    Assertions.assertEquals("bbb", erg.toString());
  }
  
  @Test
  void test6() {
    Wort erg = this.sut.berechnen("babababa");
    Assertions.assertEquals("aaaabbbb", erg.toString());
  }
  
  @Test
  void test7() {
    Wort erg = this.sut.berechnen("aaababbb");
    Assertions.assertEquals("aaaabbbb", erg.toString());
  }
  
  @Test
  void test8() {
    Wort erg = this.sut.berechnen("baaaab");
    Assertions.assertEquals("aaaabb", erg.toString());
  }
}
