package test.turingMaschine;

import org.junit.jupiter.api.Assertions;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Wort;
import alphabet.Zeichen;
import turingMaschine.TuringMaschine;
import zustand.Zustand;

public class TMPlus1Test {

  private TuringMaschine sut;
  
  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new TuringMaschine();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "turingmaschinen" + util.Util.FS + "TMPlus1.tm");
  }

  @Test
  void test1() {
    Wort erg = this.sut.berechnen("0");
    Assertions.assertEquals("1", erg.toString());
  }
  
  @Test
  void test2() {
    Wort erg = this.sut.berechnen("1");
    Assertions.assertEquals("10", erg.toString());
  }
  
  @Test
  void test3() {
    Wort erg = this.sut.berechnen("110");
    Assertions.assertEquals("111", erg.toString());
  }
  
  @Test
  void test4() {
    Wort erg = this.sut.berechnen("111");
    Assertions.assertEquals("1000", erg.toString());
  }
  
  @Test
  void test5() {
    Wort erg = this.sut.berechnen("100111");
    Assertions.assertEquals("101000", erg.toString());
  }
}
