package test.turingMaschine;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import turingMaschine.TuringMaschine;
import zustand.Zustand;


public class TMa_nccb_nTest {
  private TuringMaschine sut;

  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new TuringMaschine();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "turingmaschinen" 
          + util.Util.FS + "TMa_nccb_n.tm");
  }

  @ParameterizedTest
  @ValueSource(strings = {"accb", "aaccbb", "aaaaaccbbbbb"})
  void testOK(String wort) {
    boolean erg = this.sut.akzeptieren(wort);
    Assertions.assertTrue(erg);
  }

  @ParameterizedTest
  @ValueSource(strings = {"", "c", "cc", "ab", "abc", "b", "a", "aaccb"
      , "aaaccbbbb", "bcca"})
  void testNicht(String wort) {
    boolean erg = this.sut.akzeptieren(wort);
    Assertions.assertFalse(erg);
  }
}