package test.turingMaschine;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import turingMaschine.TuringMaschine;
import zustand.Zustand;

// benoetigt  TMcca_nb_n.tm
public class TMcca_nb_nTest {
  private TuringMaschine sut;

  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new TuringMaschine();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "turingmaschinen" + util.Util.FS + "TMcca_nb_n.tm");
  }

  @Test
  void test1() {
    boolean erg = this.sut.akzeptieren("ccab");
    Assertions.assertTrue(erg);
  }
  
  @Test
  void test2() {
    boolean erg = this.sut.akzeptieren("cc");
    Assertions.assertTrue(erg);
  }

  @Test
  void test3() {
    boolean erg = this.sut.akzeptieren("ccaaabbb");
    Assertions.assertTrue(erg);
  }

  @Test
  void test4() {
    boolean erg = this.sut.akzeptieren("ccaaaaaaaaaabbbbbbbbbb");
    Assertions.assertTrue(erg);
  }

  @Test
  void test5() {
    boolean erg = this.sut.akzeptieren("");
    Assertions.assertFalse(erg);
  }

  @Test
  void test6() {
    boolean erg = this.sut.akzeptieren("cb");
    Assertions.assertFalse(erg);
  }

  @Test
  void test7() {
    boolean erg = this.sut.akzeptieren("cab");
    Assertions.assertFalse(erg);
  }

  @Test
  void test8() {
    boolean erg = this.sut.akzeptieren("cccab");
    Assertions.assertFalse(erg);
  }

  @Test
  void test9() {
    boolean erg = this.sut.akzeptieren("ccaacbb");
    Assertions.assertFalse(erg);
  }

  @Test
  void test10() {
    boolean erg = this.sut.akzeptieren("aabbc");
    Assertions.assertFalse(erg);
  }
}
