package test.turingMaschine;

import org.junit.jupiter.api.Assertions;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import turingMaschine.TuringMaschine;
import zustand.Zustand;

public class TmBeispiel6_3_4Test {

  private TuringMaschine sut;
  
  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new TuringMaschine();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "turingmaschinen" + util.Util.FS + "TmBeispiel6_3_4ww.tm");
  }

  @Test
  void test1() {
    this.sut.berechnen("ata");
    Assertions.assertTrue(this.sut.isHalt());
  }
  
  @Test
  void test2() {
    this.sut.berechnen("btb");
    Assertions.assertTrue(this.sut.isHalt());
  }
  
  @Test
  void test3() {
    this.sut.berechnen("t");
    Assertions.assertTrue(this.sut.isHalt());
  }
  
  @Test
  void test4() {
    this.sut.berechnen("abbatabba");
    Assertions.assertTrue(this.sut.isHalt());
  }
  
  @Test
  void test5() {
    try {
      this.sut.berechnen("bbb");
      Assertions.fail();
    } catch(IllegalStateException e) {
    }
  }
  
  @Test
  void test6() {
    try {
      this.sut.berechnen("bbb");
      Assertions.fail();
    } catch(IllegalStateException e) {
    }
  }
  
  @Test
  void test7() {
    try {
      this.sut.berechnen("atb");
      Assertions.fail();
    } catch(IllegalStateException e) {
    }
  }
  
  @Test
  void test8() {
    try {
      this.sut.berechnen("abbtabbb");
      Assertions.fail();
    } catch(IllegalStateException e) {
    }
  }
  
  @Test
  void test9() {
    try {
      this.sut.berechnen("abbbtabb");
      Assertions.fail();
    } catch(IllegalStateException e) {
    }
  }
  
  @Test
  void test10() {
    try {
      this.sut.berechnen("a");
      Assertions.fail();
    } catch(IllegalStateException e) {
    }
  }
}
