package test.turingMaschine;

import org.junit.jupiter.api.Assertions;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import turingMaschine.TuringMaschine;
import zustand.Zustand;

public class TmBeispiel6_3_3Test {

  private TuringMaschine sut;

  @BeforeEach
  void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new TuringMaschine();
    this.sut.dateiEinlesen("beispiele" + util.Util.FS + "turingmaschinen" + util.Util.FS + "TmBeispiel6_3_3a2n.tm");
  }

  @Test
  void test1() {
    boolean erg = this.sut.akzeptieren("a");
    Assertions.assertTrue(erg);
  }

  @Test
  void test2() {
    boolean erg = this.sut.akzeptieren("aa");
    Assertions.assertTrue(erg);
  }

  @Test
  void test3() {
    boolean erg = this.sut.akzeptieren("aaaa");
    Assertions.assertTrue(erg);
  }

  @Test
  void test4() {
    boolean erg = this.sut.akzeptieren(
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
    Assertions.assertTrue(erg);
  }

  @Test
  void test5() {
    boolean erg = this.sut.akzeptieren("");
    Assertions.assertFalse(erg);
  }

  @Test
  void test6() {
    boolean erg = this.sut.akzeptieren("aaa");
    Assertions.assertFalse(erg);
  }

  @Test
  void test7() {
    boolean erg = this.sut.akzeptieren("aaaaa");
    Assertions.assertFalse(erg);
  }

  @Test
  void test8() {
    boolean erg = this.sut.akzeptieren("aaaaaa");
    Assertions.assertFalse(erg);
  }

  @Test
  void test9() {
    boolean erg = this.sut.akzeptieren("aaaaaaa");
    Assertions.assertFalse(erg);
  }

  @Test
  void test10() {
    boolean erg = this.sut.akzeptieren(
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
    Assertions.assertFalse(erg);
  }
}
